UNIT mTAnwendung;

interface

uses    mSuM, mUhr, mTAuto,
       mTKnopf, mTKreisknopf, mTRechteckKnopf;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KEnde : TRechteckknopf;
        dieUhr : Uhr;
        dasAuto : TAuto;

     //Objektbeziehungen:
        // hatTRechteckKnopf : TRechteckKnopf;
        // hatTKreisKnopf1, // hatTKreisKnopf2 : TKreisKnopf;
        // hat     MAUS      :      MAUS     ;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(20,500,10,'+',dieMaus);
  KLangsamer    := TKreisknopf.init(60,500,10,'---',dieMaus);
  KEnde         := TRechteckknopf.init(90,500,80,'ENDE',dieMaus);
  dasAuto       := TAuto.init (10,300,0);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt then begin
            dasAuto.schneller
         end
         else if KLangsamer.angeklickt then begin
            dasAuto.langsamer
         end;
         dasAuto.bewegeDich;
         dieUhr.warte(10);
         if dasAuto.hPosition > derBildschirm.breite + 50 then
            dasAuto.setzeAuf(0,300) 
   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  KLangsamer.gibFrei;
  KSchneller.gibFrei;
  KEnde.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
