UNIT mTAuto;

interface

uses  mSuM,mUhr;

    const laenge = 60.0;
          breite = 30.0;
// Uses-Klausel ggf. anpassen

type
   TAuto = CLASS

     // Attribute
     private
        meinStift : Stift;
        dieTastatur : Tastatur;
        meineUhr : Uhr;
        x : zahl;
        y : zahl;
        zGeschwindigkeit : Zahl;
        zWinkel : zahl;

     // Methoden
     private
        procedure zeichneDich;
        function orientierung : integer;
     public
        constructor init(px,py:zahl;pWinkel:Zahl);
        procedure bewegeDich;
        procedure dreheBis(pWinkel:zahl);
        procedure dreheUm(pWinkel:zahl);
        procedure langsamer;
        procedure schneller;
        procedure setzeAuf(pXpos,pYPos:zahl);
        procedure warte;
        function hPosition : zahl;
        function vPosition : zahl;
        function winkel : zahl;
        destructor GibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAuto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneDich (private) ---------------------------------------
procedure TAuto.zeichneDich;
  begin
    with meinStift do
      begin
        hoch;
        bewegeBis(x,y);
        wechsle;
        dreheBis(zWinkel);
        bewegeUm(laenge*0.1);
        dreheBis (zWinkel+90);
        bewegeUm(breite *0.5);
        runter;
        bewegeUm(-breite);
        hoch;
        bewegeUm(breite*0.5);
        //runter;
        dreheBis(zWinkel+180);
        BewegeUm(laenge*0.5);
        BewegeUm(laenge*0.1);
        dreheUm(-90);
        BewegeUm(breite*0.5);
        dreheUm(-90);

        runter;
        dreheBis(zwinkel);
        BewegeUm(laenge*0.8);
        DreheUm(-90);
        BewegeUm(breite*0.2);
        DreheUm(90);
        bewegeUm(laenge*0.2);
        DreheUm(-90);
        bewegeUm(breite*0.6);
        dreheUm(-90);
        bewegeUm(laenge*0.2);
        dreheUm(90);
        bewegeUm(breite*0.2);
        dreheUm(-90);
        bewegeUm(laenge*0.8);
        dreheUm(-90);
        bewegeUm(breite);
        hoch;
        bewegeUm(-breite*0.5);
        dreheBis(zwinkel);
        bewegeUm(laenge*0.5);
        normal
      end;
  end;

//-------- orientierung (private) --------------------------------------
function TAuto.orientierung : integer;
   begin
      if (zwinkel >= 45) and (zwinkel < 135) then
         orientierung := 2
      else
         if (zwinkel >= 135) and (zWinkel < 225) then
            orientierung := 3
         else
            if (zwinkel >= 225) and (zWinkel < 315) then
               orientierung := 4
            else
               orientierung := 0
   end;



//-------- init (public) -----------------------------------------------
constructor TAuto.init(px,py:zahl;pWinkel:Zahl);
    begin
       meinStift := Stift.init;
       meineUhr := Uhr.init;
       dieTastatur := Tastatur.init;
       x := px;
       y := py;
       zwinkel := pWinkel;
       zGeschwindigkeit := 3;
       zeichneDich;
    end;

//-------- bewegeDich (public) -----------------------------------------
procedure TAuto.bewegeDich;
  begin
    zeichneDich;
    x := x + zGeschwindigkeit * cos(zwinkel*pi/180);
    y := y - zGeschwindigkeit * sin(zwinkel*pi/180);
    zeichneDich;
    meineUhr.warte(1)
  end;

//-------- dreheBis (public) -------------------------------------------
procedure TAuto.dreheBis(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- dreheUm (public) --------------------------------------------
procedure TAuto.dreheUm(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := zwinkel + pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- langsamer (public) ------------------------------------------
procedure TAuto.langsamer;
begin
  zGeschwindigkeit := zGeschwindigkeit - 0.1
end;

//-------- schneller (public) ------------------------------------------
procedure TAuto.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.1
end;

//-------- setzeAuf (public) -------------------------------------------
procedure TAuto.setzeAuf(pXpos,pYPos:zahl);
   begin
      zeichneDich;
      x := pXpos ;
      y := pYpos ;
      zeichneDich
   end;

//-------- warte (public) ----------------------------------------------
procedure TAuto.warte;
   begin
      meineUhr.warte(1)
   end;

//-------- hPosition (public) ------------------------------------------
function TAuto.hPosition : zahl;
   begin
    result := x;
   end;

//-------- vPosition (public) ------------------------------------------
function TAuto.vPosition : zahl;
   begin
    result := y;
   end;

//-------- winkel (public) ---------------------------------------------
function TAuto.winkel : zahl;
   begin
    result := zWinkel;
   end;

//-------- GibFrei (public) --------------------------------------------
destructor TAuto.GibFrei;
    begin
      meinStift.gibfrei;
      meineUhr.gibfrei;
      dieTastatur.gibFrei;
    end;  

end.

